#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$pages_prev = "3";
$pages_next = "3";


##################################################################################

print "Content-type: text/html\n\n";


$gsettings = new_gsettings acs; 

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$mtype = $q->param('mtype');
$cat_keywords = $q->param('keywords');

if ($cat_keywords eq "") 
	{
	&display_no_matches;
	}

$keywords = $q->param('keywords');
$o_keywords = $q->param('keywords'); $o_keywords =~ s/ /+/gi;

if ($mtype ne "andkeywords")
	{
	$andor1 = "OR";
	}
	elsif ($mtype eq "andkeywords")
	{
	$andor1 = "AND";
	}

### BUILD SQL QUERY

if ($cat_keywords =~ / /)
	{
	@allkeys = split (/ /, $cat_keywords);
	foreach $item (@allkeys)
		{
		if (($item ne "") and (length($item) > 2))
			{
			$scrit = $scrit . "((l1 like '%$item%') or (l2 like '%$item%') or (l3 like '%$item%') or (l4 like '%$item%') or (l5 like '%$item%') or (l6 like '%$item%') or (l7 like '%$item%') or (l8 like '%$item%') or (l9 like '%$item%') or (l10 like '%$item%') or (l11 like '%$item%') or (l12 like '%$item%') or  (l13 like '%$item%') or  (l14 like '%$item%') or  (l15 like '%$item%') or  (l16 like '%$item%'))   $andor1";
			}
		}
	
	$scrit = substr($scrit, 0, length($scrit) -3);
	}
	else
	{
	$scrit = "(l1 like '%$cat_keywords%') or (l2 like '%$cat_keywords%') or (l3 like '%$cat_keywords%') or (l4 like '%$cat_keywords%') or (l5 like '%$cat_keywords%') or (l6 like '%$cat_keywords%') or (l7 like '%$cat_keywords%') or (l8 like '%$cat_keywords%') or (l9 like '%$cat_keywords%') or (l10 like '%$cat_keywords%') or (l11 like '%$cat_keywords%') or (l12 like '%$cat_keywords%') or  (l13 like '%$cat_keywords%') or  (l14 like '%$cat_keywords%') or  (l15 like '%$cat_keywords%') or  (l16 like '%$cat_keywords%')";
	}

######

if (($mtype eq "internal") or ($mtype eq ""))
	{
	$wsql = "SELECT * FROM dirs WHERE $scrit";
	}
	elsif ($mtype eq "andkeywords")
	{
	$wsql = "SELECT * FROM dirs WHERE $scrit";
	}
	elsif ($mtype eq "phrase")
	{
	$wsql = "SELECT * FROM dirs WHERE (l1 like '%$cat_keywords%') or (l2 like '%$cat_keywords%') or (l3 like '%$cat_keywords%') or (l4 like '%$cat_keywords%') or (l5 like '%$cat_keywords%') or (l6 like '%$cat_keywords%') or (l7 like '%$cat_keywords%') or (l8 like '%$cat_keywords%') or (l9 like '%$cat_keywords%') or (l10 like '%$cat_keywords%') or (l11 like '%$cat_keywords%') or (l12 like '%$cat_keywords%') or  (l13 like '%$cat_keywords%') or  (l14 like '%$cat_keywords%') or  (l15 like '%$cat_keywords%') or  (l16 like '%$cat_keywords%')";
	}


######

$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows(); 


if ($rows < 1) { &display_no_matches; exit }

### PREPARE PAGES
$icnt = $rows;
$nr_searchres = $gsettings->{cp_search_listings};
if ($nr_searchres eq "") { $nr_searchres = 10; }

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;

$ippc = 1;
####

if ($gsettings->{dirsearch_cat_sep} eq "") { $gsettings->{dirsearch_cat_sep} = " > "; }

$nrc = 1;


while ( @row = $sth->fetchrow() )
	{ 
	
	if (($ippc > $st) and ($ippc <= $nd)) 
	{

		$catmatch = "";
		$catmatch2 = "";
		$catmatch3 = "";
		$realenc = "";
		$lv = 1;
		for ($ms = 2; $ms < 18; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				$encdir = acs::encode_dir($row[$ms]);
				$realenc = $realenc . $encdir;
				
				
					## EDIT
					$catmatch = $catmatch . qq[<a href="$admin_url/admin70.cgi?lv=$lv&ct=$realenc&fct=editop" onClick="popup('$admin_url/admin70.cgi?lv=$lv&ct=$realenc&fct=editop',screen.width-250,screen.height-250);return false;">$row[$ms]</a>] . $gsettings->{dirsearch_cat_sep};

					if ($row[29] < 1)
					{
					## WEB
					$catmatch2 = $catmatch2 . "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$realenc\" target=\"_blank\">$row[$ms]</a>" . $gsettings->{dirsearch_cat_sep};
					## ADM
					$catmatch3 = $catmatch3 . "<a href=\"$admin_url/admin70.cgi?lv=$lv&ct=$realenc&fct=admin\" target=\"_blank\">$row[$ms]</a>" . $gsettings->{dirsearch_cat_sep};
					}
					
					
				$realenc = $realenc . "-";
				$lv++;
				}
			} 
		
		$catmatch = substr($catmatch, 0, length($catmatch) - 3);
		$catmatch2 = substr($catmatch2, 0, length($catmatch2) - 3);
		$catmatch3 = substr($catmatch3, 0, length($catmatch3) - 3);
	

	
		#print $catmatch . "<BR>";
		#print $row[18] . "<BR>"; ## DIZ


if ($catmatch2 eq "") { $catmatch2 = "Crosslinked"; }
if ($catmatch3 eq "") { $catmatch3 = "Crosslinked"; }

$crossl = "";
if ($row[29] > 0) { $crossl = "<BR><img src=\"$web_url/dircross.gif\">"; }


$all_links = $all_links . qq[


<table border="0" cellpadding="6" cellspacing="3" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="1" rowspan="3" align="center" class="normaltext"
    style="border-right: 1px solid rgb(224,224,224)" valign="top"><strong>$nrc. $crossl </strong></td>
    <td class="normaltext">Edit:&nbsp; $catmatch </td>
  </tr>
  <tr>
    <td class="normaltext">Adm: $catmatch3 </td>
  </tr>
  <tr>
    <td class="normaltext">Web: $catmatch2 </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>

];

	}
	
	$nrc++;
	$ippc++;
	}


$sth->finish;
$dbh->disconnect;






#### PAGES 

	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				$pgstring = $pgstring . "<a href=\"$admin_url/admin69.cgi?st=$st&nd=$nd&keywords=$o_keywords&mtype=$mtype\">$pg</a> ";
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = "<a href=\"$admin_url/admin69.cgi?st=$pvst&nd=$pvnd&keywords=$o_keywords&mtype=$mtype\"><</a> " . $pgstring;
				}             

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;
				$pgstring = $pgstring . "<a href=\"$admin_url/admin69.cgi?st=$pvst&nd=$pvnd&keywords=$o_keywords&mtype=$mtype\">></a> ";
				}


### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

if ($nd <= ($icnt - $spls))
{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin69.cgi?st=$st1&nd=$nd1&keywords=$o_keywords&mtype=$mtype\">$gsettings->{nextpage}</a> ";
}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin69.cgi?st=$st1&nd=$nd1&keywords=$o_keywords&mtype=$mtype\">$gsettings->{prevpage}</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}


########

if ($nr_searchres == 10) { $v10 = "selected"; }
if ($nr_searchres == 20) { $v20 = "selected"; }
if ($nr_searchres == 30) { $v30 = "selected"; }
if ($nr_searchres == 40) { $v40 = "selected"; }
if ($nr_searchres == 50) { $v50 = "selected"; }
if ($nr_searchres == 75) { $v75 = "selected"; }
if ($nr_searchres == 100) {$v100 = "selected"; }
if ($nr_searchres == 200) {$v200 = "selected"; }
if ($nr_searchres == 500) { $v500 = "selected"; }
if ($nr_searchres == 1000) { $v1000 = "selected"; }



print qq[
<html>
<head>
<title>PowerSeek</title>
<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);

  		var shih = screen.height-250;
    	var swid = screen.width-250;
	   var winl = (screen.width-swid)/2;
		var wint = (screen.height-shih)/2;
    
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',left=' + winl + ',top=' + wint;
    
    
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }

// End Hide -->
</script>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>

<body>


<form method="POST" action="$admin_url/admin69.cgi">
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td width="100%" bgcolor="#0000A0"><img src="$web_url/cpsearch.jpg"> </td>
    </tr>
  </table>
  <div align="center"><center><table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="6"
  cellspacing="1" width="100%" style="border: 1px solid rgb(221,221,221)">
    <tr>
      <td width="722" colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Category
      Search Options:</strong></td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Keywords: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="text" name="keywords"
      size="59" value="$keywords"> </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Search with: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="radio" value="internal"
      name="mtype" checked> At least one keyword should match a category name <br>
      <input type="radio" value="andkeywords" name="mtype"> All the keywords supplied must match
      category names <br>
      <input type="radio" value="phrase" name="mtype"> Search with the exact phrase. (The phrase
      must match to find a match) </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"></td>
      <td width="563" valign="top" class="normaltext"><input type="submit"
      value="Search Categories / Directories" name="B2"> </td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="6"
  cellspacing="0" width="100%">
    <tr>
      <td width="50%" class="normaltext"><strong>Found $rows Matches</strong></td>
      <td width="50%" class="normaltext" align="right"><select name="listperpage1" size="1"
      style="font-family: MS Sans Serif; font-size: 8pt">
        <option $v10 value="10">List 10 Links Per Page</option>
        <option $v20 value="20">List 20 Links Per Page</option>
        <option $v30 value="30">List 30 Links Per Page</option>
        <option $v40 value="40">List 40 Links Per Page</option>
        <option $v50 value="50">List 50 Links Per Page</option>
        <option $v75 value="75">List 75 Links Per Page</option>
        <option $v100 value="100">List 100 Links Per Page</option>
        <option $v200 value="200">List 200 Links Per Page</option>
        <option $v500 value="500">List 500 Links Per Page</option>
        <option $v1000 value="1000">List 1000 Links Per Page</option>
      </select><input type="submit" value="   Go   " name="ppga"
      style="font-family: MS Sans Serif; font-size: 8"
      onClick="popup('$admin_url/admin11.cgi?fct=setpage&amp;v=' + listperpage1.value,600,110);return false;"></td>
    </tr>
    <tr>
      <td width="50%" class="normaltext">$prevnext </td>
      <td width="50%" align="right" class="normaltext">Pages: $pages | $pgstring </td>
    </tr>
  </table>
  </center></div><p>$all_links</p>
  <div align="center"><center><table border="0" cellpadding="6" cellspacing="0" width="100%">
    <tr>
      <td width="50%" class="normaltext">$prevnext </td>
      <td width="50%" align="right" class="normaltext">Pages: $pages | $pgstring </td>
    </tr>
  </table>
  </center></div>
</form>


</body>
</html>

];



sub display_no_matches
{

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
</head>
<body>


<form method="POST" action="$admin_url/admin69.cgi">
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td width="100%" bgcolor="#0000A0"><img src="$web_url/cpsearch.jpg"></td>
    </tr>
  </table>
  <div align="center"><center><table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="6"
  cellspacing="1" width="100%" style="border: 1px solid rgb(221,221,221)">
    <tr>
      <td colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Category        Search Options:</strong></td>
      </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Keywords: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="text" name="keywords" size="59"
      value="$keywords"> </td>
    </tr>
    <tr>
      <td width="159" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Search with: </strong></td>
      <td width="563" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="radio" value="internal"
      name="mtype" checked> At least one keyword should match a category name <br>
      <input type="radio" value="andkeywords" name="mtype"> All the keywords supplied must match
      category names <br>
      <input type="radio" value="phrase" name="mtype"> Search with the exact phrase. (The phrase
      must match to find a match) </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"></td>
      <td width="563" valign="top" class="normaltext"><input type="submit" value="Search Categories / Directories"
      name="B2"> </td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
  </center></div>
</form>
<div align="center"><center>

<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="100%" class="normaltext"><strong>Found 0 Matches </strong></td>
  </tr>
  <tr>
    <td width="100%" class="normaltext">Use more or different keywords. </td>
  </tr>
</table>
</center></div>


</body>
</html>
];
exit;

}




####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

